/*
 * blanco Framework
 * Copyright (C) 2004-2006 IGA Tosiki
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.stringgroup.task;

import java.io.File;
import java.io.IOException;

import javax.xml.transform.TransformerException;

import blanco.stringgroup.BlancoStringGroupConstants;
import blanco.stringgroup.BlancoStringGroupMeta2Xml;
import blanco.stringgroup.BlancoStringGroupXml2SourceFile;
import blanco.stringgroup.resourcebundle.BlancoStringGroupResourceBundle;

/**
 * 「文字列グループ定義書」Excel様式から文字列グループを処理するクラス・ソースコードを生成。
 * 
 * このクラスは、Apache Antタスクを実装します。
 * 
 * @author IGA Tosiki
 */
public class BlancoStringGroupTask extends AbstractBlancoStringGroupTask {
    /**
     * このプロダクトのリソースバンドルへのアクセスオブジェクト。
     */
    private final BlancoStringGroupResourceBundle bundle = new BlancoStringGroupResourceBundle();

    /**
     * 定義書(XLS)からソースコードを自動生成するApache Antタスクのエントリポイントです。
     */
    protected void process() throws IllegalArgumentException {
        System.out.println("- " + BlancoStringGroupConstants.PRODUCT_NAME
                + " (" + BlancoStringGroupConstants.VERSION + ")");

        try {
            final File fileMetadir = new File(getMetadir());
            if (fileMetadir.exists() == false) {
                throw new IllegalArgumentException(bundle
                        .getAnttaskErr001(getMetadir()));
            }

            // テンポラリディレクトリを作成。
            new File(getTmpdir()
                    + BlancoStringGroupConstants.TARGET_SUBDIRECTORY).mkdirs();

            // 指定されたメタディレクトリを処理します。
            new BlancoStringGroupMeta2Xml().processDirectory(fileMetadir,
                    getTmpdir()
                            + BlancoStringGroupConstants.TARGET_SUBDIRECTORY);

            // XML化された中間ファイルからソースコードを生成
            final File[] fileMeta2 = new File(getTmpdir()
                    + BlancoStringGroupConstants.TARGET_SUBDIRECTORY)
                    .listFiles();
            for (int index = 0; index < fileMeta2.length; index++) {
                if (fileMeta2[index].getName().endsWith(".xml") == false) {
                    continue;
                }

                new BlancoStringGroupXml2SourceFile().process(fileMeta2[index],
                        getTargetlang(), new File(getTargetdir()));
            }
        } catch (IOException ex) {
            throw new IllegalArgumentException(ex.toString());
        } catch (TransformerException ex) {
            throw new IllegalArgumentException(ex.toString());
        } catch (IllegalArgumentException ex) {
            ex.printStackTrace();
            throw ex;
        }
    }
}
